const {initRequest,debug}= require('./utils');
//import css from "./css.css"

class offsetItem{
    /**
     *
     * @param {textArea}area
     */
    constructor({area}) {
        this.area= area;
        this.init();
    }
    init(){
        let me= document.createElement('div');
        me.classList.add('it');
        this.area.content.appendChild(me);
        this.me=me;
        this.setOffset(0,0);
    }
    setOffset(s,e){
        if(s==e) return;
        this.area.textarea.focus();
        this.area.textarea.setSelectionRange(s,e );
        let y=this.area.getPosFromOffset(s,e);
        let ps=this.area.getPosFromOffset(s,s);
        let pe=this.area.getPosFromOffset(e,e);
        let h= -ps.pos.top + pe.pos.top;
        let line =parseInt( this.area.mirror.style.lineHeight);
        debug(s,e,y.range.toString(), h/line );

    }
    setOffset_old(s,e){
         const {pos}= this.area.getPosFromOffset(s,e);
         let width = pos.right-pos.left;
         let height = pos.bottom-pos.top;
        this.me.style.left=  pos.left+'px';
        //this.me.style.right=  pos.right+'px';
         this.me.style.top= pos.top + 'px';//pos.bottom +
         this.me.style.height= height +'px';
         this.me.style.width= width+'px';
        // this.me.style.bottom=  pos.bottom+'px';
        debug('height:',height,'width:',width,"x:",pos.x,"y:", pos.y );
    }
}

class textArea{
    /**
     *
     * @param {HTMLTextAreaElement} textarea
     */
    constructor( {textarea,css}) {
        this.textarea= textarea;//文本
        this.css= css;
        this.mirror=null;//镜像
        this.el=null;//shadow-root 根目录

        console.log('ddd>>', textarea.tagName)
        if(textarea.tagName!='TEXTAREA') throw "this no textarea";
        this.initConfig();
        this.init();
    }
    initConfig(){
        this.coords= this.getCoords(this.textarea) //坐标
        console.log('coords',this.coords )
    }
    init(){

        this.createShadowBoot().createMirror();
        this.insertCss().setMirrorText();

        let a= new offsetItem({area:this});
        this.sleep(1000).then( ()=>a.setOffset(20,58) ) ;
        this.sleep(1500).then( ()=>a.setOffset_old(51,52) ) ;
        this.sleep(2500).then( ()=>a.setOffset_old(51,59) ) ;
    }
    sleep(t){
        return new Promise(h=> setTimeout(d=>h(d),t));
    }
    getCoords (node){
        var x = node.offsetLeft;
        var y = node.offsetTop;
        var parent = node.offsetParent;
        while (parent != null){
            x += parent.offsetLeft;
            y += parent.offsetTop;
            parent = parent.offsetParent;
        }
        return {x: x, y: y};
    }
    createShadowBoot(){
        let d2= document.createElement('pigai-textarea');
        d2.style="mix-blend-mode: darken; position: absolute; top: 0px; left: 0px; pointer-events: none;";
        let shadowDom =  d2.attachShadow({ mode: 'open' });
        let pElem = document.createElement('div');
        //pElem.innerHTML = 'hello shadow';
        pElem.classList.add( 'root');
        let score= document.createElement('div');
        score.classList.add('scroll');
        let contentM= document.createElement('div');
        contentM.classList.add('content-mather');
        let content= document.createElement('div');
        content.classList.add('content')
        contentM.appendChild(content);
        score.appendChild(contentM);
        pElem.appendChild(score);
        shadowDom.appendChild(pElem);
        //d.ass
        let h= document.getElementsByTagName('head' )[0];
        h.parentNode.insertBefore(d2, h);
        this.el= d2.shadowRoot;
        this.content=content;
        this.contentM=contentM;
        this.scroll = score;
        return this;
    }
    setMirrorText(){
        if(this.mirror.childNodes.length<=0){
            let d=document.createTextNode(this.textarea.value);
            this.mirror.appendChild(d);
            console.log("mirror", this.mirror.childNodes );
        }else{
            this.mirror.childNodes[0].data = this.textarea.value;
        }

        return this;
    }
    //mirror image
    createMirror(){
        let d2= document.createElement('pigai-mirror');
        let shadowDom =  d2.attachShadow({ mode: 'open' });
        let m= document.createElement('div');
        /**
         * margin: 0px;
         *     box-sizing: content-box;
         *     border-width: 0px;
         *     width: 400px;
         *     height: 300px;
         *     padding: 2px;
         *     font: 400 16px / 40px -apple-system, "system-ui", "Helvetica Neue", Helvetica, "Segoe UI", Arial, Roboto, "PingFang SC", miui, "Hiragino Sans GB", "Microsoft Yahei", sans-serif;
         *     direction: ltr;
         *     text-align: left;
         *     text-shadow: none;
         *     text-indent: 0px;
         *     letter-spacing: normal;
         *     word-break: normal;
         *     word-spacing: 0px;
         *     writing-mode: horizontal-tb;
         *     white-space: pre-wrap;
         *     vertical-align: baseline;
         */
        let style=['margin','boxSizing','borderWidth','width','height','font','padding','direction'
            ,'textAlign','text-shadow','text-indent','letter-spacing','word-break',' word-spacing','writing-mode'
            ,'white-space','vertical-align'];
        // const { font,padding,border,borderWidth} =window.getComputedStyle(this.textarea);
        // debug('font>',font);
        // debug('padding>',padding );
        // debug('border>',border );
        // debug('borderWidth>',borderWidth );
        let tStyle = window.getComputedStyle(this.textarea);
        debug('css>',this.css );
        for(let p of style ){
            m.style[p]= tStyle[p];
        }
        //m.style.
        m.style.position='fixed';
        m.style.zIndex=-20000;
        //m.style.visibility="hidden"
        m.style.left=0; m.style.top=0;
        this.mirror= m;
        shadowDom.appendChild(this.mirror);
        document.body.parentNode.appendChild(d2);
        return this;
    }
    getPosFromOffset(s,e){
        let  range =  document.createRange();
        range.setStart(this.mirror.childNodes[0],s);
        range.setEnd(this.mirror.childNodes[0],e);
        let pos= range.getBoundingClientRect();
        //debug(pos.left,pos.right,pos.top,pos.bottom ,range.toString() );
        return {pos,range};
    }
    drawDiv(){

    }
    insertCss(){
        let style= document.createElement('style');
        let tStyle = window.getComputedStyle(this.textarea);
        let width= parseInt(tStyle.width)+parseInt(tStyle.paddingLeft)+parseInt(tStyle.paddingRight);
        let height= parseInt( tStyle.height) + parseInt(tStyle.paddingTop)+ parseInt(tStyle.paddingBottom);
        let top= this.coords.y+parseInt(tStyle.borderTopWidth)+'px';
        let left= this.coords.x+parseInt(tStyle.borderLeftWidth)+'px';

        style.innerHTML=`.root{
        position: absolute; top: 0px; left: 0px;
        }
        .scroll{
            position: relative;
            pointer-events: none;
            width:${width}px;
            height:${height}px;
            padding:0;border:0;
            margin:0;
            overflow:hidden;
            left:${left}; top:${top}
        }
        .content-mather{
            position: absolute; top: 0px; left: 0px;
        }
        .content{
           height:2380px;
           width:1380px;
        }
        .it{
            position:absolute;background-color:rgba(0,0,0,0.5);
            transition:width 1s;
        }
        `;
            //${tStyle.padding}
        this.el.insertBefore(style,this.el.childNodes[0]);

        return this;
    }
}
class pigaiTextarea {

    /**
     *
     * @param {axios} axios
     */
    constructor({axios,css}) {
        this.request =  initRequest({axios});
        this.css=css;
        this.init();
    }
    init(){
        debug('这边初始化');
        this.reg();
    }
    reg(){
        let texts= document.getElementsByTagName('textarea');
        console.log(texts.length )
        if(texts.length<=0) return;
        for(let i=0;i<texts.length;i++ ){
            new textArea({textarea:texts[i],css:this.css});
        }
    }
    test(){
        debug('good news');
    }

}
module.exports=pigaiTextarea;