
/**
 *
 * @param {axios} axios
 * @returns {axios}
 */
export function initRequest( {axios} ){
    let service = axios.create({
        headers:{'Content-Type':'application/x-www-form-urlencoded'},
        baseURL:'',
        timeout:10000
    })
    service.defaults.withCredentials = true;
    service.interceptors.request.use(
        config=>{
            config.headers['Content-Type'] = config.headers['Content-Type']? config.headers['Content-Type']: 'application/x-www-form-urlencoded';
            if(config.method == 'post' && config.headers['Content-Type'] == 'application/x-www-form-urlencoded'){
                let d='';
                for(let p in config.data){
                    d+= encodeURIComponent(p)+'='+encodeURIComponent( config.data[p])+'&';
                }
                config.data=d;
            }
            //config.url='/pigai'+config.url+"&_display=json";
            //console.log('url>> ',config);
            return config;
        },error => Promise.reject(error)
    );
    service.interceptors.response.use(res=>{
            return res.data;
        }
        ,error=>{
            let opt={
                error:105,error_des:'服务器连接错误', data:error
            }
            //this.cb(opt);
            return Promise.reject(error);
        });

    return service;
}

export function debug(...e){
    console.log('%c[PG]','color:blue',...e);
}

